<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: ALM_CajaChicaCab.xml */
/* Generado: 2020-08-18 04:21:23 */

/* Mantenimiento de los registros de la tabla ALM_CajaChicaCab */
abstract class BaseALM_CajaChicaCabDP extends ALM_CajaChicaCabBV
{
    /* Constructor ( Establece los valores desde un objeto ALM_CajaChicaCabBN ) */
    public function __construct( ALM_CajaChicaCabBN $o_ALM_CajaChicaCabBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_ALM_CajaChicaCabBN ) )
        {
            $this->setByBN( $o_ALM_CajaChicaCabBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto ALM_CajaChicaCabBN */
    public function setByBN( ALM_CajaChicaCabBN $o_ALM_CajaChicaCabBN )
    {
        if ( !is_null( $o_ALM_CajaChicaCabBN->getIdCaja() ) )
        {
            $this->setIdCaja( $o_ALM_CajaChicaCabBN->getIdCaja() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_ALM_CajaChicaCabBN->getIdCompania() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_ALM_CajaChicaCabBN->getIdSucursal() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_ALM_CajaChicaCabBN->getDescripcion() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getFechaCaja() ) )
        {
            $this->setFechaCaja( $o_ALM_CajaChicaCabBN->getFechaCaja() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getFechaCierreCaja() ) )
        {
            $this->setFechaCierreCaja( $o_ALM_CajaChicaCabBN->getFechaCierreCaja() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getMontoFondo() ) )
        {
            $this->setMontoFondo( $o_ALM_CajaChicaCabBN->getMontoFondo() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getMontoSaldoAnt() ) )
        {
            $this->setMontoSaldoAnt( $o_ALM_CajaChicaCabBN->getMontoSaldoAnt() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getMontoIngreso() ) )
        {
            $this->setMontoIngreso( $o_ALM_CajaChicaCabBN->getMontoIngreso() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getMontoSaldoAct() ) )
        {
            $this->setMontoSaldoAct( $o_ALM_CajaChicaCabBN->getMontoSaldoAct() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getEstado() ) )
        {
            $this->setEstado( $o_ALM_CajaChicaCabBN->getEstado() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getEnUsoFlag() ) )
        {
            $this->setEnUsoFlag( $o_ALM_CajaChicaCabBN->getEnUsoFlag() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_ALM_CajaChicaCabBN->getFechaCreacion() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_ALM_CajaChicaCabBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_ALM_CajaChicaCabBN->getFechaModificacion() );
        }
        if ( !is_null( $o_ALM_CajaChicaCabBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_ALM_CajaChicaCabBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_ALM_CajaChicaCabFN = new ALM_CajaChicaCabFN();
        $o_ALM_CajaChicaCabBN = $o_ALM_CajaChicaCabFN->selectByPk( $this->getIdCaja() );
        if ( is_null( $o_ALM_CajaChicaCabBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO ALM_CajaChicaCab ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCaja() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCaja";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCaja()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCaja() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCaja";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCaja()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCierreCaja() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCierreCaja";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCierreCaja()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoFondo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoFondo";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoFondo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoSaldoAnt() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoSaldoAnt";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoSaldoAnt()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoIngreso() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoIngreso";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoIngreso()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoSaldoAct() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoSaldoAct";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoSaldoAct()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEnUsoFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EnUsoFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEnUsoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE ALM_CajaChicaCab SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCaja() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCaja = '".$this->getFechaCaja()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCierreCaja() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCierreCaja = '".$this->getFechaCierreCaja()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoFondo() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoFondo = ".$this->getMontoFondo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoSaldoAnt() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoSaldoAnt = ".$this->getMontoSaldoAnt()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoIngreso() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoIngreso = ".$this->getMontoIngreso()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoSaldoAct() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoSaldoAct = ".$this->getMontoSaldoAct()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEnUsoFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."EnUsoFlag = '".$this->getEnUsoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdCaja = ".$this->getIdCaja().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM ALM_CajaChicaCab WHERE  IdCaja = ".$this->getIdCaja().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>